/**
 * NOTE: This class is auto generated by the swagger code generator program (3.0.34).
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */
package io.swagger.api;

import io.swagger.document.AddressDoc;
import io.swagger.document.EducationDoc;
import io.swagger.document.PersonDoc;
import io.swagger.model.Address;
import io.swagger.model.Education;
import io.swagger.model.Person;
import io.swagger.model.PersonUpdate;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.enums.ParameterIn;
import io.swagger.v3.oas.annotations.responses.ApiResponses;
import io.swagger.v3.oas.annotations.responses.ApiResponse;
import io.swagger.v3.oas.annotations.media.ArraySchema;
import io.swagger.v3.oas.annotations.media.Content;
import io.swagger.v3.oas.annotations.media.Schema;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

import javax.validation.Valid;
import java.util.List;

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.SpringCodegen", date = "2022-07-28T02:56:17.552Z[GMT]")
@Validated
public interface ApiApi {

    @Operation(summary = "", description = "", tags={ "person-controller" })
    @ApiResponses(value = {
            @ApiResponse(responseCode = "200", description = "OK", content = @Content(mediaType = "*/*", schema = @Schema(implementation = Person.class))) })
    @RequestMapping(value = "/api/person",
            produces = { "application/json"},
            method = RequestMethod.POST)
    ResponseEntity<PersonDoc>createPerson(@Parameter(in = ParameterIn.DEFAULT, description = "", required=true, schema=@Schema()) @Valid   @RequestBody Person person);

    @Operation(summary = "", description = "", tags={ "person-controller" })
    @ApiResponses(value = {
            @ApiResponse(responseCode = "200", description = "OK", content = @Content(mediaType = "*/*", schema = @Schema(implementation = Person.class))) })
    @RequestMapping(value = "/api/person/{id}",
            produces = { "application/json"},
            method = RequestMethod.GET)
    ResponseEntity<Person> getPersonById(@Parameter(in = ParameterIn.PATH, description = "", required=true, schema=@Schema()) @PathVariable("id") String id);


    @Operation(summary = "", description = "", tags={ "person-controller" })
    @ApiResponses(value = {
            @ApiResponse(responseCode = "200", description = "OK", content = @Content(mediaType = "*/*", array = @ArraySchema(schema = @Schema(implementation = Person.class)))) })
    @RequestMapping(value = "/api/person",
            produces = { "application/json" },
            method = RequestMethod.GET)
    ResponseEntity<Iterable<PersonDoc>> getAllPerson();


    @Operation(summary = "", description = "", tags={ "person-controller" })
    @ApiResponses(value = { 
        @ApiResponse(responseCode = "200", description = "OK", content = @Content(mediaType = "*/*", schema = @Schema(implementation = Person.class))) })
    @RequestMapping(value = "/api/person",
        produces = { "application/json" },
        method = RequestMethod.PUT)
    ResponseEntity<PersonDoc> updatePerson( @Parameter(in = ParameterIn.DEFAULT, description = "", required=true, schema=@Schema()) @Valid @RequestBody PersonUpdate personUpdate);


    @Operation(summary = "", description = "", tags={ "person-controller" })
    @ApiResponses(value = {
            @ApiResponse(responseCode = "200", description = "OK", content = @Content(mediaType = "*/*", schema = @Schema(implementation = String.class))) })
    @RequestMapping(value = "/api/person/{id}",
            produces = { "*/*" },
            method = RequestMethod.DELETE)
    ResponseEntity<String> deletePerson(@Parameter(in = ParameterIn.PATH, description = "", required=true, schema=@Schema()) @PathVariable("id") String id);




    @Operation(summary = "", description = "", tags={ "address-controller" })
    @ApiResponses(value = {
            @ApiResponse(responseCode = "200", description = "OK", content = @Content(mediaType = "*/*", schema = @Schema(implementation = Address.class))) })
    @RequestMapping(value = "/api/address",
            produces = { "application/json"  },
            method = RequestMethod.POST)
    ResponseEntity<AddressDoc> createAddress(@Parameter(in = ParameterIn.DEFAULT, description = "", required=true, schema=@Schema()) @Valid @RequestBody Address body);

    @Operation(summary = "", description = "", tags={ "address-controller" })
    @ApiResponses(value = {
            @ApiResponse(responseCode = "200", description = "OK", content = @Content(mediaType = "*/*", array = @ArraySchema(schema = @Schema(implementation = Address.class)))) })
    @RequestMapping(value = "/api/address",
            produces = { "application/json"},
            method = RequestMethod.GET)
    ResponseEntity<Iterable<AddressDoc>> getAllAddress();

    @Operation(summary = "", description = "", tags={ "address-controller" })
    @ApiResponses(value = {
            @ApiResponse(responseCode = "200", description = "OK", content = @Content(mediaType = "*/*", schema = @Schema(implementation = Address.class))) })
    @RequestMapping(value = "/api/address/{id}",
            produces = {"application/json"},
            method = RequestMethod.GET)
    ResponseEntity<Address> getAddressById(@Parameter(in = ParameterIn.PATH, description = "", required=true, schema=@Schema()) @PathVariable("id") String id);

    @Operation(summary = "", description = "", tags={ "address-controller" })
    @ApiResponses(value = {
            @ApiResponse(responseCode = "200", description = "OK", content = @Content(mediaType = "*/*", schema = @Schema(implementation = Address.class))) })
    @RequestMapping(value = "/api/address/{id}",
            produces = { "*/*" },
            consumes = { "application/json" },
            method = RequestMethod.POST)
    ResponseEntity<Address> updateAddress(@Parameter(in = ParameterIn.PATH, description = "", required=true, schema=@Schema()) @PathVariable("id") String id, @Parameter(in = ParameterIn.DEFAULT, description = "", required=true, schema=@Schema()) @Valid @RequestBody Address body);

    @Operation(summary = "", description = "", tags={ "address-controller" })
    @ApiResponses(value = {
            @ApiResponse(responseCode = "200", description = "OK", content = @Content(mediaType = "*/*", schema = @Schema(implementation = String.class))) })
    @RequestMapping(value = "/api/address/{id}",
            produces = { "*/*" },
            method = RequestMethod.DELETE)
    ResponseEntity<String> deleteAddress(@Parameter(in = ParameterIn.PATH, description = "", required=true, schema=@Schema()) @PathVariable("id") String id);





    @Operation(summary = "", description = "", tags={ "education-controller" })
    @ApiResponses(value = {
            @ApiResponse(responseCode = "200", description = "OK", content = @Content(mediaType = "*/*", schema = @Schema(implementation = Education.class))) })
    @RequestMapping(value = "/api/education",
            produces = { "application/json"},
            method = RequestMethod.POST)
    ResponseEntity<EducationDoc> createEducation(@Parameter(in = ParameterIn.DEFAULT, description = "", required=true, schema=@Schema()) @Valid @RequestBody Education body);

    @Operation(summary = "", description = "", tags={ "education-controller" })
    @ApiResponses(value = {
            @ApiResponse(responseCode = "200", description = "OK", content = @Content(mediaType = "*/*", array = @ArraySchema(schema = @Schema(implementation = Education.class)))) })
    @RequestMapping(value = "/api/education",
            produces = {"application/json" },
            method = RequestMethod.GET)
    ResponseEntity<Iterable<EducationDoc>> getAllEducation();



    @Operation(summary = "", description = "", tags={ "education-controller" })
    @ApiResponses(value = {
            @ApiResponse(responseCode = "200", description = "OK", content = @Content(mediaType = "*/*", schema = @Schema(implementation = Education.class))) })
    @RequestMapping(value = "/api/education/{id}",
            produces = {"application/json" },
            method = RequestMethod.GET)
    ResponseEntity<Education> getEducationById(@Parameter(in = ParameterIn.PATH, description = "", required=true, schema=@Schema()) @PathVariable("id") String id);

    @Operation(summary = "", description = "", tags={ "education-controller" })
    @ApiResponses(value = {
            @ApiResponse(responseCode = "200", description = "OK", content = @Content(mediaType = "*/*", schema = @Schema(implementation = String.class))) })
    @RequestMapping(value = "/api/education/{id}",
            produces = { "*/*" },
            method = RequestMethod.DELETE)
    ResponseEntity<String> deleteEducation(@Parameter(in = ParameterIn.PATH, description = "", required=true, schema=@Schema()) @PathVariable("id") String id);

    @Operation(summary = "", description = "", tags={ "education-controller" })
    @ApiResponses(value = {
            @ApiResponse(responseCode = "200", description = "OK", content = @Content(mediaType = "*/*", schema = @Schema(implementation = Education.class))) })
    @RequestMapping(value = "/api/education/{id}",
            produces = { "application/json" },
            method = RequestMethod.POST)
    ResponseEntity<Education> updateEducation(@Parameter(in = ParameterIn.PATH, description = "", required=true, schema=@Schema()) @PathVariable("id") String id, @Parameter(in = ParameterIn.DEFAULT, description = "", required=true, schema=@Schema()) @Valid @RequestBody Education body);





}

